From 3b738601fe970af4b4439466c4e2852878817585 Mon Sep 17 00:00:00 2001
From: Egbert Eich <eich@suse.com>
Date: Thu, 19 May 2022 09:48:08 +0200
Subject: [PATCH 28/30] Add missing calls to slurm_msg_set_r_uid()

Signed-off-by: Egbert Eich <eich@suse.com>
---
 src/common/slurm_protocol_api.c | 17 ++++++++++++++++-
 1 file changed, 16 insertions(+), 1 deletion(-)

diff --git a/src/common/slurm_protocol_api.c b/src/common/slurm_protocol_api.c
index 1e17d301ab..cfdd29ce15 100644
--- a/src/common/slurm_protocol_api.c
+++ b/src/common/slurm_protocol_api.c
@@ -4547,7 +4547,14 @@ int slurm_send_rc_err_msg(slurm_msg_t *msg, int rc, char *err_msg)
 	resp_msg.forward_struct = msg->forward_struct;
 	resp_msg.ret_list = msg->ret_list;
 	resp_msg.orig_addr = msg->orig_addr;
-
+	/* like _resp_msg_setup() */
+	if (!msg->auth_uid_set)
+                slurm_msg_set_r_uid(&resp_msg, SLURM_AUTH_NOBODY);
+        else if ((msg->auth_uid != slurm_get_slurm_user_id()) &&
+                 (msg->auth_uid != slurm_get_slurmd_user_id()))
+                slurm_msg_set_r_uid(&resp_msg, msg->auth_uid);
+        else
+                slurm_msg_set_r_uid(&resp_msg, SLURM_AUTH_UID_ANY);
 	/* send message */
 	return slurm_send_node_msg(msg->conn_fd, &resp_msg);
 }
@@ -4584,6 +4591,14 @@ int slurm_send_reroute_msg(slurm_msg_t *msg, slurmdb_cluster_rec_t *cluster_rec)
 	resp_msg.ret_list         = msg->ret_list;
 	resp_msg.orig_addr        = msg->orig_addr;
 
+	/* like _resp_msg_setup() */
+	if (!msg->auth_uid_set)
+                slurm_msg_set_r_uid(&resp_msg, SLURM_AUTH_NOBODY);
+        else if ((msg->auth_uid != slurm_get_slurm_user_id()) &&
+                 (msg->auth_uid != slurm_get_slurmd_user_id()))
+                slurm_msg_set_r_uid(&resp_msg, msg->auth_uid);
+        else
+                slurm_msg_set_r_uid(&resp_msg, SLURM_AUTH_UID_ANY);
 	/* send message */
 	return slurm_send_node_msg(msg->conn_fd, &resp_msg);
 }
-- 
2.35.3


